# Problemas de Desenvolvimento
# 5.5

# importando bibliotecas
import matplotlib.pyplot as p
from numpy import arange as intervalo

# dados
Tas = intervalo(-22.5,25.0, 0.25)
Pres = []

for Ta in Tas:
    Pres.append(100*(293/(Ta+273.15)))

# a
p.clf()    # limpa qualquer figura anteriormente plotada
p.plot(Tas, Pres, '-.k')
p.xlabel('Ta(°C)')
p.ylabel('P(kPa)')
p.legend('P')
p.title('Temperatura (°C) versus Pressão (kPa)')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

p.tight_layout() # faz o ajuste do layout da Figura automaticamente
p.show()

# método otimizado. Após estudar arrays, você verá os códigos de forma
# mais simplificada. No entanto, para você ir se acostumando, segue um
# exemplo de solução simplificada
# dados
Ta2 = intervalo(-22.5,25.0, 0.25)
Pres2 = 100*(293/(Ta2+273.15))

# a
p.figure(2)
p.clf()    # limpa qualquer figura anteriormente plotada
p.plot(Ta2, Pres2, '--b')
p.xlabel('Ta(°C)')
p.ylabel('P(kPa)')
p.legend('P')
p.title('Temperatura (°C) versus Pressão (kPa)')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

p.tight_layout() # faz o ajuste do layout da Figura automaticamente
p.show()