# Problemas de Desenvolvimento
# 5.7

# importando bibliotecas
import matplotlib.pyplot as p
from numpy import linspace as intervalo

# dados
Ts = intervalo(0.0, 40.0, 100)
Ro = []

for T in Ts:
    Ro.append(1000*(0.863559 + 1.21494*10**(-3)*T - 2.5708*10**(-6)*T**2))

# a
p.clf()    # limpa qualquer figura anteriormente plotada
p.plot(Ts, Ro, '-.k')
p.xlabel('T(°C)')
p.ylabel('Ro(kg/m3)')
p.legend('Ro')
p.title('Temperatura (°C) versus Densidade (kg/m3)')
p.grid(visible=True, linewidth=0.1, linestyle='-', color='k')

p.tight_layout() # faz o ajuste do layout da Figura automaticamente
p.show()

# método otimizado. Após estudar arrays, você verá os códigos de forma
# mais simplificada. No entanto, para você ir se acostumando, segue um
# exemplo de solução simplificada. Perceba que os resultados são idênticos
# dados
T = intervalo(0.0, 40.0, 100)
RO = 1000*(0.863559 + 1.21494*10**(-3)*T - 2.5708*10**(-6)*T**2)

# a
p.figure(2)
p.clf()    # limpa qualquer figura anteriormente plotada
p.plot(T, RO, '--b')
p.xlabel('T(°C)')
p.ylabel('Ro(kg/m3)')
p.legend('Ro')
p.title('Temperatura (°C) versus Densidade (kg/m3)')
p.grid(visible=True, linewidth=0.1, linestyle='-', color='k')

p.tight_layout() # faz o ajuste do layout da Figura automaticamente
p.show()