# Problemas de Desenvolvimento
# 5.8

# importando bibliotecas
import numpy as np
from pylab import meshgrid
import matplotlib.pyplot as p
from mpl_toolkits.mplot3d import Axes3D

# declaração de variáveis
T = np.linspace(290.15, 318.15, 50)   # °C
STD = np.linspace(650.8, 2700.5, 50)  # mg/L

# gerando uma malha de dados
t,std = meshgrid(T, STD)

# calculando os custos de aquisição com os valores da malha
mi_efluente = 10**(-3)*((0.33*std/2) + 2.3)/(1 + 0.0337*t + 0.000221*t**2)

# gerando uma figura independente
fig = p.figure()

# configurando a dimensão da figura
dim = fig.gca(projection='3d')

# aplicando legendas nos eixos x, y e z
dim.set_xlabel('T(°C)')
dim.set_ylabel('STD(mg/L)')
dim.set_zlabel('mi_efluente(kg/ms)')

# plotando os dados de x, y e z
dim.plot_surface(t, std, mi_efluente, linewidth=0, antialiased=True, cmap='Oranges')
# mostrando o gráfico
p.show()
# na área do gráfico, clique, segure e arraste o mause para ver o que acontece.