# Problemas de Revisão
# 5.2

# importando bibliotecas
import matplotlib.pyplot as p
# dados
x = list(range(7))
ya = [0.9, 0.95, 0.94, 0.93, 0.9, 0.89, 0.85]
yb = [0.05, 0.04, 0.04, 0.04, 0.05, 0.06, 0.07]
yc = [0.05, 0.01, 0.02, 0.03, 0.05, 0.05, 0.08]

# gráfico da composição A
p.clf()    # limpa qualquer figura anteriormente plotada
p.subplot(2,2,1)
p.plot(x, ya, '--or')
# aplicação dos detalhes do gráfico
p.xlabel('x-t(h)')
p.ylabel('composição (A)')
p.legend('A')
p.title('Tempo (h) versus Composição')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

# gráfico da composição B
p.subplot(2,2,2)
p.plot(x, yb, '-*b')
# aplicação dos detalhes do gráfico
p.xlabel('x-t(h)')
p.ylabel('composição (B)')
p.legend('B')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

# gráfico da composição C
p.subplot(2,2,3)
p.plot(x, yc, '-.1g')
# aplicação dos detalhes do gráfico
p.xlabel('x-t(h)')
p.ylabel('composição (C)')
p.legend('C')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

# gráfico da carga térmica
t = list(range(7))
Q = [25.8, 28.38, 31.218, 34.3398, 30.9058, 27.8152, 25.0337]
p.subplot(2,2,4)
p.plot(t, Q, '->m')
p.xlabel('t(h)')
p.ylabel('Q(kJ/h)')
p.legend('Q(kJ/h)')
p.title('Tempo (h) versus Carga Térmica')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')

p.tight_layout() # faz o ajuste do layout da Figura automaticamente
p.show()

