# Problemas de Revisão
# 5.3

# importando bibliotecas
import matplotlib.pyplot as p
from numpy import linspace as intervalo
from numpy import sqrt as raiz
#from math import sqrt as raiz
from math import pi
# dados
xs = intervalo(-1.5,4.5,100)

# aqui podemos resolver o problema de duas maneiras:
# 1
# cálculo realizado elemento por elemento dentro de um laço de repetição
fx = []
for x in xs:
    fx.append((raiz(1.56 + x)/(1+2.71828**x)-(x**2)/pi))

# a
p.clf()    # limpa qualquer figura anteriormente plotada
p.plot(xs, fx, '--or')
p.xlabel('x')
p.ylabel('f(x)')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')
p.show()

# solução 2: otmizada: usando arrays
# 2 - cálculo vetorizado aplicando apenas uma linha de código na função
from numpy import array
xs = intervalo(-1.5,4.5,100)
fx2 = array([])
fx2 = (raiz(1.56 + xs)/(1+2.71828**xs)-(xs**2)/pi)

p.figure(2) # cria uma segunda figura para não apagar a primeira
p.clf()    # limpa a figura 2 anteriormente plotada
p.plot(xs, fx2, '--<b')
p.xlabel('x')
p.ylabel('f2(x)')
p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')
p.show()

# veremos arrays em capítulos mais adiante! :D