	# Problemas de Revisão
# 5.4

# importando bibliotecas
import numpy as np
from numpy import sqrt as raiz
from pylab import meshgrid
import matplotlib.pyplot as p
from mpl_toolkits.mplot3d import Axes3D
# declaração de variáveis
X1 = np.linspace(-40.0, 45.0, 100)
X2 = np.linspace(-15.0, 4.5, 100)

# gerando uma malha de dados
x1,x2 = meshgrid(X1, X2)

# calculando os custos de aquisição com os valores da malha
fx1x2 = x2*x1**2 - (x2**3)*x1 + (x1*x2/raiz(1+x1*x1)) - x1**3

# gerando uma figura independente
fig = p.figure()

# configurando a dimensão da figura
#dim = fig.gca(projection='3d') # modo antigo
dim = fig.add_subplot(projection='3d')  # modo novo
# aplicando legendas nos eixos x, y e z
dim.set_xlabel("x1")
dim.set_ylabel("x2")
dim.set_zlabel("f(x1,x2)")

# plotando os dados de x, y e z
dim.plot_surface(x1, x2, fx1x2, linewidth=0, antialiased=True, cmap='Blues')
# mostrando o gráfico
p.show()
