# Problemas de Desenvolvimento
# 10.13 - página 270
# falor futuro

# importando bibliotecas
import matplotlib.pyplot as p
from math import exp, sinh
from numpy import sin, radians
from numpy import linspace as intervalo

# declaração das funções
def func_senoh(x): # esta é a função proposta pelo problema
    senohiperbolico = []
    # teste de troca de valores
    if type(x)==float:
        senohiperbolico.append((exp(x)-exp(-x))/2)
    else:
        for xi in x:
            senohiperbolico.append((exp(xi)-exp(-xi))/2)
    return senohiperbolico    
    
def func_sinh(x): # esta é a função original
    # intervalo de x
    sinohiperbolic = []
    # teste de troca de valores
    if type(x)==float:
        sinohiperbolic.append(sinh(x))
    else:
        for xi in x:
            sinohiperbolic.append(sinh(xi))
    return sinohiperbolic 
    
    
# declaração das funções
def meu_plot(x, sinH_problem, sinH_python):
    p.clf()    # limpa qualquer figura anteriormente plotada
    p.plot(x, sinH_problem, '-k', x, sinH_python, '*r')
    p.xlabel('x')
    p.ylabel('f(x)')
    p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')
    p.show()
    
    
# exemplo de aplicação 01
# a função sin é calculada utilizando radianos como referência
# por isso a necessidade de transformar os valores de graus para radiano
x = float(radians(85)) # 85 graus
sinH_problem = func_senoh(x)        # seno hiperbólico do problema
sinH_python = func_sinh(x)          # seno hiperbólico da biblioteca math
print('resultado da função proposta é',
      sinH_problem, '\nResultado da função da biblioteca é', sinH_python)


# exemplo de aplicação 02
# a função sin é calculada utilizando radianos como referência
# por isso a necessidade de transformar os valores de graus para radiano
x = radians(intervalo(0, 360, 20)) # variáveis
sinH_problem = func_senoh(x)        # seno hiperbólico do problema
sinH_python = func_sinh(x)          # seno hiperbólico da biblioteca math
meu_plot(x, sinH_problem, sinH_python) # plotando o comportamento das funções


