# Problemas de Revisão
# 10.16 - página 271
# curva de pH entre um ácido e uma base fortes

# importando bilbiotecas
import matplotlib.pyplot as p
from numpy import log10, arange


def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'b:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura



# exemplo de aplicação
# declarando variáveis

# dados do ácido
v_naoh = 25.0                   # volume da amostra (mL)
m_naoh = 0.10                   # concentração NaOH (mol/L)
m_hcl = 0.10                    # concentração do HCl (mol/L)

# declarando variáveis
n_naoh = m_naoh*v_naoh          # quantidade de matéria (mol)
# dados da base
v_hcl = arange(0.0,50.0, 0.1)   # lista com volumes de HCl (mL)

# criação de uma lista vazia para armazenamento dos valores de pH
pH = []

# repetindo os cálculos para cada ml de HCl da lista v_hcl
for v_hcli in v_hcl:
    n_hcl = m_hcl*v_hcli        
    if v_hcli < v_naoh:
        # ph antes do ponto de equivalência
        mt = (n_naoh - n_hcl)/(v_naoh + v_hcli)          
        ph = 14 + log10(mt)
    elif v_hcli > v_naoh:
        # ph após do ponto de equivalência
        mt = (n_hcl - n_naoh)/(v_naoh + v_hcli)
        ph = -log10(mt)
    else:
        # ph no ponto de equivalência
        ph = -log10(1e-7)
    pH.append(ph)


#---visualizando o comportamento do pH em um gráfico
rotulo_x = 'HCl (ml)'
rotulo_y = 'pH'
legenda = ['pH']
titulo = 'Curva de Neutralização'
plotagem(v_hcl, pH, rotulo_x, rotulo_y, legenda, titulo)


