# Problemas de Desenvolvimento
# 10.17 - página 271
# função seno

# importando bilbiotecas
import matplotlib.pyplot as p

# declaração das funções
def meu_fatorial(ns):
    fatorial = 1
    for n in range(1,ns+1):
        fatorial*=n
    return fatorial

def meu_seno(x, n_termos = 100):
    soma = 0.0
    # número de repetições baseado no número de termos do usuário
    for n in range(0, n_termos):                
        soma = soma + ((-1)**n)*x**(2*n+1)/(meu_fatorial(2*n+1))  # o valor atual é igual ao valor anterior + 1/n!
    return soma

def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'b:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura



# Precisamos usar um laço para que n varie de zero até um valor para o
# qual a soma seja praticamente constante. Despois que isso for alcançado
# traçamos o gráfico
    
# número de termos
n_termos = 0
# entrando com o valor de x
x = 5.0

val1 = 1
val2 = 3
counter = 0
n=[]
seno = []

'''
# o valor máximo de repetições foi 80 devido à dificuldade de armazenamento
# dos valores do fatorial. Com valores bem menores que 80 já temos bons resul
tados.

Outra informação: O laço while foi usado. Caso você ainda não tenha usado
este laço de repetição, modifique o código e aplique o laço for.
'''
while abs(val1-val2)>1e-16 and counter < 80:
    val1 = val2
    val2 = meu_seno(x, n_termos)
    n.append(n_termos)
    seno.append(val2)
    n_termos+=1
    counter+=1
  
rx = 'Número de termos n'
ry = 'seno(5)'
legenda = ['seno(x)']
plotagem(n,seno,rx,ry, legenda, titulo = 'Meu gráfico')

