# Problemas de Revisão
# 10.1 - página 268
# funções de plotagem de gráfico

# importando bibliotecas
import numpy as np
from pylab import meshgrid
import matplotlib.pyplot as p
from numpy import sqrt as raiz
from mpl_toolkits.mplot3d import Axes3D

# declaração de funções
def meu_plot(x,y,rx,ry,legenda, titulo = 'Meu gráfico'):

    p.clf()    # limpa qualquer figura anteriormente plotada
    p.figure(0)
    p.plot(x,y)
    p.xlabel(rx)
    p.ylabel(ry)
    p.legend(legenda)
    p.title(titulo)
    p.grid(visible=True,linewidth=0.1, linestyle='-', color='k')
    p.show()

def meu_plot_3D(x,y,fx,rx,ry,legenda,titulo = 'Meu gráfico 3D'):
    # declaração de variáveis
    X = np.linspace(x[0], x[1], 100)
    Y = np.linspace(y[0], y[1], 100)
    
    # gerando uma malha de dados
    x1,x2 = meshgrid(X, Y)
    
    # calculando os custos de aquisição com os valores da malha
    fx1x2 = fx(x1,x2)
    #fx1x2 = x1*x2**2 - (x1**3)*x2*x2 + (x1*x2/raiz(1+x1*x1)) + x2**3
    #fx1x2 = x2*x1**2 - (x2**3)*x1 + (x1*x2/raiz(1+x1*x1)) - x1**3
    print('ok')
    # gerando uma figura independente
    fig = p.figure(1)
    
    # configurando a dimensão da figura
    dim = fig.add_subplot(projection='3d')
    
    # aplicando legendas nos eixos x, y e z
    dim.set_xlabel(rx)
    dim.set_ylabel(ry)
    dim.set_zlabel("z=f(x,y)")
    
    # plotando os dados de x, y e z
    dim.plot_surface(x1, x2, fx1x2,
                     linewidth=0,
                     antialiased=True,
                     cmap='Oranges')
    # mostrando o gráfico
    p.show()

### ---------------------------------------------------- ###

# exemplo de aplicação para o gráfico x versus y
x = [0.5, 1.2, 2.8, 4.2, 5.5, 7.2, 8.5]
y = [25.8, 22.2, 15.6, 10.2, 15.0, 22.8, 26.8]
rx = 'x'
ry = 'f(x)'
legenda = 'f(x)'
meu_plot(x,y,rx,ry,legenda)




# exemplo de aplicação para o gráfico 3D Z(x,y)
# definição da função
fxy = lambda x,y: (x - y + x**3*y - 2*x*y/(raiz(1+x*x)) - x*y**3)*10
#fxy = lambda x1,x2:x2*x1**2 - (x2**3)*x1 + (x1*x2/raiz(1+x1*x1)) - x1**3
# definição dos intervalores de x e de y
x = [-1.8, 3.5] # [valor inicial, falor final]
y = [-2.5, 5.45] # [valor inicial, falor final]

# rótulos e legendas
rx = 'valores de x'
ry = 'valores de y'
legenda = 'f(x,y) = Z'
meu_plot_3D(x,y,fxy,rx,ry,legenda)





