# Problemas de Revisão
# 11.16 - página 332
# carregando dados de um arquivo xlsx

#importando bibliotecas
import pandas as pd
import matplotlib.pyplot as p


'''
# em um outro arquivo você pode carregar os dados da planilha conforme
# linhas de código a seguir. Lembre-se de que o arquivo excel foi salvo
# na mesma pasta desta resposta. Caso você carregue os dados por outro 
# arquivo, terá que aplicar o caminho da pasta na qual o arquivo se encontra.

lembre-se que são necessárias as bibliotecas panda e matplotlib
'''

# carregando os dados
dados_arquivo = pd.read_excel('dados_temperatura.xlsx')
# renomeando a coluna de horários, caso não queira renomear, basta usar o
# nome completo 'Unnamed: 0'
dados_arquivo.rename(columns={'Unnamed: 0':'tempo(h)'}, inplace=True )
print(dados_arquivo)

# plotando os dados
dados_arquivo.plot(x='tempo(h)', y='Temperatura', ylabel = 'T(°C)', xlabel = 't(h)', linestyle = '--')
p.xticks(rotation=45) # fazendo os horários aparecerem com inclinação de 45°
p.tight_layout()
p.show()

# perceba que a quantidade de dados não fica muito legível no nosso gráfico!
# desta forma, seria mais interessante plotar apenas uma parte dos dados
# veja a resposta a seguir


# resposta otimizada
# plotando os dados

#  salvando apenas uma fração de todos os dados ( os primeiros 30 valores)
# aqui temos o número de linhas (0:30), e as acolunas que queremos ['tempo(h)', 
# 'Temperatura']
fatia = dados_arquivo.loc[0:30, ['tempo(h)', 'Temperatura']]
fatia.plot(x='tempo(h)', y='Temperatura', 
           ylabel = 'T(°C)', xlabel = 't(h)', 
           linestyle = '--', color = 'k')
p.xticks(rotation=45) # fazendo os horários aparecerem com inclinação de 45°
p.tight_layout()
p.show()

# você pode brincar com essa resposta tentando aplicar um laço de repetição e 
# fazer com que seu código plot os 30 últimos dados atualizando o gráfico
# a cada rodada. Ex. primeiro o laço de repetição plotará os dados de 0 a 30
# na próxima rodada, o gráfico apresenta os daados de 1 a 31, e assim por 
# diante... tente.


