# Problemas de Desenvolvimento
# 11.17 - página 332
# refluxo mínimo

#importando bibliotecas
from numpy import linspace as intervalo
import matplotlib.pyplot as p


def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'k:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura



Xd = 0.4
Xf = 0.9
alfa = intervalo(0.1,0.99,50)

#***** forma de resolução 01: método clássico de programação   *****
Rm = []
for alfai in alfa:
    Rmi = (1/(alfai - 1))*((Xd/Xf) - alfai*(1-Xd)/(1-Xf))
    Rm.append(Rmi)

# plotando os resultados
plotagem(alfa, Rm,'alfa', 'Rm', ['Rm'])






#***** forma de resolução 02: método otimizado   *****
a = intervalo(0.1,0.99,50)
Rm2 = (1/(a - 1))*((Xd/Xf) - a*(1-Xd)/(1-Xf))
# plotando os resultados
plotagem(a, Rm2,'alfa', 'Rm2', ['Rm'])





#***** forma de resolução 03: método adaptativo ótimo   *****
# declaração da função
def func_Rm(alfa, Xd, Xf):
    Rm = (1/(alfa - 1))*((Xd/Xf) - alfa*(1-Xd)/(1-Xf))
    return Rm

# plotando os resultados
plotagem(a, func_Rm(a,Xd, Xf),'alfa', 'Rm2', ['Rm'])    