# Problemas de Desenvolvimento
# 11.18 - página 332
# queda de pressão

#importando bibliotecas
import matplotlib.pyplot as p
from numpy import array
# declarando variáveis
Dv = 0.65
Dl = 0.88
Vg = 55.7
K = array([0.3, 0.95])

dP = K*(Dv/Dl)*Vg**2                # Ex 11.16

posicoes = list(range(len(dP)))     # gerando uma lista de posições

p.clf() # limpando figuras anteriores
#usando argumentos para a função bar
p.bar(posicoes, dP, align='center', width=0.5, color=['blue','orange'] )

# ajustando a nomenclatura do eixo para cada barra
legendas = ['orifício', 'valvulado']   # legenda para cada uma das barras
p.xticks(posicoes, legendas)           # colocando legenda para cada barra
p.ylabel('Queda de Pressão (deltaP)')          # legenda do eixo y
p.xlabel('Coeficiente de Orifício (K)')        # legenda do eixo x
p.show()                                       # mostrando o gráfico
