# Problemas de Desenvolvimento
# 11.19 - página 332
# viscosidade

#importando bibliotecas
from numpy import exp, delete, where, linspace as intervalo
import matplotlib.pyplot as p


def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'k:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura



Xd = 0.4
Xf = 0.9
Ts = intervalo(-459.6,459.6,100)

#***** forma de resolução 01: método clássico de programação   *****
mi = []
for Ti in Ts:
    if Ti != -459.6:
        mi_i = exp((7445.3/(Ti+459.6)) - 6.1076)
        mi.append(mi_i)

# plotando os resultados
if any(Ts==-459.6):
    
    Ts = delete(Ts, where(Ts== -459.6))
    

plotagem(Ts, mi,'T(°F)', 'Viscosidade (cP)', ['cP'])




