# Problemas de Desenvolvimento
# 11.7 - página 330
# Newton Raphson

# ** primeiro abra o arquivo prob_des_11_7_pag_330_veja_me_antes.py

# usando a biblioteca do sympy
#importando bibliotecas
from sympy import Symbol, Derivative, cos, log, exp, diff
'''
para aplicarmos o symbol como método de resolução precisamos usar
as funções da própria biblioteca sympy
'''
# declaração das variáveis
x = Symbol('x')

# declaração da função
fx = x**2 - 10*x**3 + 1/((1+x**2)**0.5) # Ex. 11.3

## explicando que exp(x) = 2.718281828459045**x
#fx = 15*x**2 - 2.718281828459045**(x)  # Ex. 11.4

#fx = cos(x) - x**2 + log(x,10)         # Ex. 11.5 ** leia a nota no final


# declaração da derivada
dfx = Derivative(fx, x).doit()  # esta ou a de baixo funcionam para derivar sua função
#dfx = diff(fx, x).doit()

#contador de segurança n iniciando em 1
n = 1
#estimativas iniciais de x0 e x1
x0 = 0.05

#método de Newton-Raphson
while (abs(fx.subs(x, x0)) > 1e-5 and n < 100):
    # método de Newton-Raphson
    x0 = x0 - (fx.subs(x, x0)/dfx.subs(x, x0))
    n += 1

#imprimindo os resultados
if n < 100:
    msg = 'Para a Equação 11.3 uma raíz é:'  # mude o nome da equação quando mudar o problema
    print(msg, x0)
else:
    msg = 'Solução não encontrada para o númerode iterações.\n'
    msg+= 'aumente o número de iterações ou a tolerância e tente novamente.'
    print(msg)


#######---------------------------------------------------------------------------###################
# ** caso a resolução da função 11.5 esteja muito lenta no seu computador
# você pode tentar outra solução, como segue:
    
from scipy.misc import derivative
from numpy import log10, cos

# declaração da função
def f3(x):
    fx = cos(x) - x**2 + log10(x)             # Ex. 11.5
    return fx

# declaração da derivada
def df3(x):
    dfx = derivative(f3, x, dx=1e-6)
    return dfx


#contador de segurança n iniciando em 1
n = 1
#estimativas iniciais de x0 e x1
x0 = 0.05

#método de Newton-Raphson
while (abs(f3(x0)) > 1e-5 and n < 100):
    # método de Newton-Raphson
    x0 = x0 - f3(x0)/df3(x0)
    n += 1

#imprimindo os resultados
if n < 100:
    msg = 'Pelo método 2, para a Equação 11.3 uma raíz é:'
    print(msg, x0)
else:
    msg = 'Solução não encontrada para o númerode iterações.\n'
    msg+= 'aumente o número de iterações ou a tolerância e tente novamente.'
    print(msg)


#######---------------------------------------------------------------------------###################
# **Nota 2: caso do método derivative do scipy não esteja mais disponível
# para uso por obsolescência, verifique se a biblioteca findiff está
# instalada. Caso não esteja presente no seu anaconda, use a linha
# conda install -c conda-forge findiff no seu anaconda prompt (veja anexo do livro!)
# Após instalação, aplique o método a seguir:
# from numpy import linspace as intervalo    
# from findiff import FinDiff

import numpy as np
from findiff import FinDiff
from scipy.interpolate import Akima1DInterpolator

x = np.linspace(0, 10, 100)
dx = x[1] - x[0]
fx = x**2 - 10*x**3 + 1/((1+x**2)**0.5) # Ex. 11.3

df_dx = FinDiff(0, dx)
df = df_dx(fx)
dfx = Akima1DInterpolator(x,df)

# deixando a função "chamável"
fx1113 = lambda x: x**2 - 10*x**3 + 1/((1+x**2)**0.5) # Ex. 11.3
#contador de segurança n iniciando em 1
n = 1
#estimativas iniciais de x0 e x1
x0 = 1.0

#método de Newton-Raphson
while (abs(fx1113(x0)) > 1e-5 and n < 100):
    # método de Newton-Raphson
    x0 = x0 - (fx1113(x0)/dfx(x0))
    n += 1

#imprimindo os resultados
if n < 100:
    msg = 'Pelo método 3, para a Equação 11.3 uma raíz é:'  # mude o nome da equação quando mudar o problema
    print(msg, x0)
else:
    msg = 'Solução não encontrada para o númerode iterações.\n'
    msg+= 'aumente o número de iterações ou a tolerância e tente novamente.'
    print(msg)