# Problemas de Desenvolvimento
# 11.8 - página 330
# comportamento das funções: complemento da resposta.
'''
entenda que, antes de montar seu método para determinação
de raízes, se possível, sempre tente observar o comportamento
da função. Pode ser que a função problema não tenha raíz.
Para isso, basta plotar o gráfico da função e observar se 
algum valor de f(x) corta o eixo x em algum ponto. Isso também
é estratégico para o fato de podermos escolher as melhores estima-
tivas iniciais ou as melhores faixas de trabalho para os valores
de x.

'''

# usando a biblioteca do sympy
# importando bilbiotecas
import matplotlib.pyplot as p
from numpy import linspace as intervalo, exp

def f1(x):
    fx = 0.8*x**3 + x/((1+x**2)**0.5)   # Ex. 11.6
    return fx

def f2(x):
    fx = 2*x**3 - 5.5*exp(-x)           # Ex. 11.7
    return fx

def f3(x):
    fx = 2*x**2 - 15.0*x - 5           # Ex. 11.8
    return fx



x = intervalo(-1.0, 3.0, 200)

#---visualizando o comportamento das funções em um gráfico
p.clf()                                                  # limpando figuras anteriores
p.plot(x, f1(x), ':b',x, f2(x), '--r', x, f3(x), '-k')   # plotando o gráfico
p.xlabel('x')                                            # legenda do eixo X
p.ylabel('f(x)')                                         # legenda do eixo Y
p.title('Comportamento das funções')                     # título
p.legend(['f1-11.6', 'f2-11.7', 'f3-11.8'])              # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1)          # linhas de grade
p.show()  