# Problemas de Revisão
# 11.11 - página 331
# interpolação

import matplotlib.pyplot as p
from numpy import linspace as intervalo
from scipy.interpolate import UnivariateSpline as spline


def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'b:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura


t = [0.5, 1.2, 2.8, 4.2, 5.5, 7.2, 8.5]
T = [25.8, 22.2, 15.6, 10.2, 15.0, 22.8, 26.8]

ft = spline(t,T)
ti = intervalo(0.0,10.0, 100)
# plotanto o gráfico da interpolação
plotagem(ti,ft(ti),'t(h)', 'T(°C)', ['interpolação'])

