# Problemas de Revisão
# 11.12 - página 331
# ajuste de curva

# usando a função de ajuste de curva
from numpy import array, polyfit, poly1d, corrcoef
from numpy import linspace as intervalo
import matplotlib.pyplot as p

# nossos dados experimentais 01
t1 = array([0, 1, 2, 3, 4, 5, 6])
T = array([0.5, 1.2, 2.8, 4.2, 6.9, 7.5, 8.5])

# serão usados o indice 1 para esses dados
# nossos dados experimentais 02
t2 = array([ 1, 2, 3, 4, 5, 6, 7])
A = array([0.09, 0.43, 0.83, 0.12, 0.52, 0.69, 0.62])


# calculando os coeficientes
b1, a1 = polyfit(t1, T, 1)
b2, a2 = polyfit(t2, A, 1)


# calculando o quanto a função consegue representar os dados
r = corrcoef(t1, T)[0,1]
r2 = r**2

r_2 = corrcoef(t2, A)[0,1]
r2_2 = r_2**2


# transformando os coeficientes angular e linear em uma função
func1 = poly1d([b1, a1])
func2 = poly1d([b2, a2])

# transformando nossa equação em texto que será plotado no gráfico
ftxt1 = 'y = ' + str(format(b1, '.3f')) + '*x ' + str(format(a1, '.3f')) + '\n' 
ftxt2 = 'y = ' + str(format(b2, '.3f')) + '*x ' + str(format(a2, '.3f')) + '\n' 

# transformando o resultado do cálculo de r2 em texto para o graf
rtxt1 = 'r2 = ' + str(format(r2, '.3f'))
rtxt2 = 'r2 = ' + str(format(r2_2, '.3f'))

# definindo um intervalo
ti = intervalo(0.0, 10.0, 100)

# plotando nossos dados e nossa equação 01 em um subplot 
p.clf()                              # limpando gráfico anterior, se existir
p.subplot(1, 2 , 1)
p.plot(ti, func1(ti), 'b--', t1, T, '*r')       # plotando o gráfico
p.title('Usando ajuste de curvas')              # título
p.xlabel('x')                                   # legenda do eixo X
p.ylabel('y')                                   # legenda do eixo Y
p.legend(['T(°C)' , ftxt1 + rtxt1])             # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1) #linhas de grade

# plotando nossos dados e nossa equação 02 em um subplot 
tj = intervalo(0.0, 10.0, 100)                           
p.subplot(1, 2 , 2)
p.plot(tj, func2(tj), '-k', t2, A, 'ob')        # plotando o gráfico
p.title('Usando ajuste de curvas')              # título
p.xlabel('x')                                   # legenda do eixo X
p.ylabel('y')                                   # legenda do eixo Y
p.legend(['y' , ftxt2 + rtxt2])                 # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1) #linhas de grade
p.show()                                        # mostrando o gráfico    

# perceba que os dados do segundo gráfico não se adequam muito bem 
# à regressão linear. 