# Problemas de Revisão
# 11.13 - página 331
# interpolação

import matplotlib.pyplot as p
from numpy import linspace as intervalo
from scipy.interpolate import Akima1DInterpolator as spline


def plotagem(x,y,rx,ry, legenda, titulo = 'Meu gráfico'):
    p.clf()                                         # limpando figuras anteriores
    p.plot(x, y, 'k:')                              # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura


t = [0.2, 1.3, 2.6, 3.2, 4.0, 5.6, 6.8]
Q = [25.8, 15.48, 9.288, 5.5728, 3.34368, 2.00621, 1.20372]

ft = spline(t,Q)
ti = intervalo(0.0,8.0, 100)
# plotanto o gráfico da interpolação
plotagem(ti,ft(ti),'t(h)', 'Q(kJ/h)', ['Akima-1D'])

