# Problemas de Desenvolvimento
# 14.1 - página 457

# importando bibliotecas 
from sympy import Integral, Symbol, pprint

# declaração de variáveis
T = Symbol('T')

Ti = 305.0     #  K
Tf = 517.0     #  K

Q = 51.8       # kg/s

# Capacidade Calorífica 
fCp = 0.95 + 0.00021*T    #  kJ/kg
print('Esta é a função original:')
pprint(fCp)
print(5*'--------------')

# chamando o método e integrando a função ∫(Cp)dT
W = Integral(fCp, T).doit() # doit() manda integrar a função
print('\nEsta é a função integrada:')
pprint(W)
print(5*'--------------')

# integrando a função como integral definida
W2 = Q*Integral(fCp, (T, Ti, Tf)).doit()
msg = '\nA potência dispendida é de W ='
print(msg + f' {W2:.2f}kJ/s ou W = {W2/1000:.2f}MW.')


#########---------------------------------------##################
#                 'Método de resolução 2'

print(2*'\n','Método 2:')
# importando bibliotecas 
from scipy.integrate import quad as integral

def funcCp(T):
    # Capacidade Calorífica do ar
    fCp = 0.95 + 0.00021*T 
    return fCp

# declaração de variáveis
Ti = 305.0     #  K
Tf = 517.0     #  K
Q = 51.8       # kg/s

# chamando o método e integrando a função ∫(Cp)dT no intervalo a-b
W = Q*integral(funcCp, Ti, Tf)[0]

msg = '\nA potência dispendida é de W ='
print(msg + f' {W:.2f}kJ/s ou W = {W/1000:.2f}MW.')
