# Problemas de Desenvolvimento
# 15.02 - melhores valores de x1 e x2 para maximizar a função

# importando bibliotecas

from scipy.optimize import minimize
import matplotlib.pyplot as p
from pylab import meshgrid

from numpy import linspace as intervalo, sin, exp, cos, pi


# função de plotagem 3D
def meu_plot_3D(x,y,fx,rx,ry,rz,legenda,titulo = 'Meu gráfico 3D'):
    # declaração de variáveis
    X = intervalo(x[0], x[1], 100)
    Y = intervalo(y[0], y[1], 100)
    
    # gerando uma malha de dados
    x1,x2 = meshgrid(X, Y)
    
    # aplicando os valores da malha à função
    f_x1x2 = fx1x2([x1,x2])

    print('ok')
    # gerando uma figura independente
    fig = p.figure(1)
    
    # configurando a dimensão da figura
    dim = fig.add_subplot(projection='3d')
    
    # aplicando legendas nos eixos x, y e z
    dim.set_xlabel(rx)
    dim.set_ylabel(ry)
    dim.set_zlabel(rz)
    
    # plotando os dados de x, y e z
    dim.plot_surface(x1, x2, -f_x1x2,
                     linewidth=0,
                     antialiased=True,
                     cmap='Greys')
    
    # ajustando o gráfico
    p.tight_layout()
    # mostrando o gráfico
    p.show()
    
# declaração da função objetivo
def fx1x2(x):
    soma = 0.0
    for xi in x:
        soma = soma + 10*xi**2 + (5/2)*cos(xi) - exp(xi/10) + pi*sin(1/xi) - 1.6/xi**2
    return -(soma)


# declaração dos limites (variável = [inferior,superior])
x1 = [-40.0, 40.0]
x2 = [-40.0, 40.0]
x = [x1,x2]

# estimativas iniciais
xi = [-5.0,5.0]

# chamando a função minimize para resolver o problema
solucao = minimize(fx1x2, xi, bounds = x, method='SLSQP', tol=1e-08)

# carregando os valores ótimos do x
xo = solucao.x
print(xo)

# a
# imprimindo a solução
print(f'\nOs valores encontrados foram x1={float(xo[0]): .2f} e x2={float(xo[1]): .2f}')
print(f'Aplicando esses valores à função, temos f(x1,x2)={-fx1x2(xo): ,.3f} como máximo.')


# ----------------------------------------------------------------------#

# b
'''
# para encontrar os valores de x1 e x2 que resultem no mínimo de f(x1,x2):
# 1 - substitua o -(soma) da linha 52 (return da função objetivo) por abs(soma)
# 2 - remova o sinal negativo da linha 38 (-f_x1x2). 
# 2 - comente as linhas de código 72 e 73;
# 3 - descomente as linhas 87 e 88 a seguir e rode seu código novamente.
'''
## imprimindo a solução
# print(f'\nOs valores encontrados foram x1={float(xo[0]): .6f} e x2={float(xo[1]): .6f}')
# print(f'Aplicando esses valores à função, temos f(x1,x2)={fx1x2(xo): ,.3e} como mínimo.')

# c
# plotando o gráfico da função
rx = 'x1'
ry = 'x2'
rz= 'f(x1,x2)'
legenda = 'f(x1,x2)'
meu_plot_3D(x1,x2,fx1x2,rx,ry,rz,legenda)

