# Problemas de Desenvolvimento
# 15.03 - melhores valores de x1 e x2 para maximizar a função de Ackley[22]

# importando bibliotecas

from scipy.optimize import minimize
import matplotlib.pyplot as p
from pylab import meshgrid
from numpy import array

from numpy import linspace as intervalo, exp, cos, pi, sqrt


# função de plotagem 3D
def meu_plot_3D(x,y,fx,rx,ry,rz,legenda,titulo = 'Meu gráfico 3D'):
    # declaração de variáveis
    X = intervalo(x[0], x[1], 100)
    Y = intervalo(y[0], y[1], 100)
    
    # gerando uma malha de dados
    x1,x2 = meshgrid(X, Y)
    
    # aplicando os valores da malha à função
    f_x1x2 = fx1x2(array([x1,x2]))

    print('\nimpressão ok')
    # gerando uma figura independente
    fig = p.figure(1)
    
    # configurando a dimensão da figura
    dim = fig.add_subplot(projection='3d')
    
    # aplicando legendas nos eixos x, y e z
    dim.set_xlabel(rx)
    dim.set_ylabel(ry)
    dim.set_zlabel(rz)
    
    # plotando os dados de x, y e z
    dim.plot_surface(x1, x2, -f_x1x2,
                     linewidth=0,
                     antialiased=True,
                     cmap='Spectral')
    
    # ajustando o gráfico
    p.tight_layout()
    # mostrando o gráfico
    p.show()
    
# declaração da função objetivo
def fx1x2(x):
    # declaração das constantes
    a = 20.0
    b = 0.2
    c = 2*pi
    d = len(x)
    # Ex. 15.3
    fxx = -a*exp(-b*sqrt((1/d)*sum(x*x)))-exp((1/d)*cos(sum(c*x)))+a+exp(1)
    
    return -(fxx)
    
   
# declaração dos limites (variável = [inferior,superior])
x1 = array([-35.0, 35.0])
x2 = array([-35.0, 35.0])
x = [x1,x2]

# estimativas iniciais
xi = array([-5.0,5.0])

# chamando a função minimize para resolver o problema
solucao = minimize(fx1x2, xi, bounds = x, method='SLSQP', tol=1e-08)

# carregando os valores ótimos do x
xo = solucao.x

# a
# imprimindo a solução
print(f'\nOs valores encontrados foram x1={float(xo[0]): .2f} e x2={float(xo[1]): .2f}')
print(f'Aplicando esses valores à função, temos f(x1,x2)={-fx1x2(xo): ,.3f} como máximo.')


# ----------------------------------------------------------------------#

# b
'''
# para encontrar os valores de x1 e x2 que resultem no mínimo de f(x1,x2):
# 1 - remova o sinal negativa de -(fxx) da linha 59 (return da função objetivo) 
# 2 - remova o sinal negativo da linha 39 (-f_x1x2). 
# 3 - comente as linhas de código 78 e 79;
# 4 - descomente as linhas 93 e 94 a seguir e rode seu código.
'''
# ## imprimindo a solução
# print(f'\nOs valores encontrados foram x1={float(xo[0]): .6e} e x2={float(xo[1]): .6e}')
# print(f'Aplicando esses valores à função, temos f(x1,x2)={fx1x2(xo): ,.3f} como mínimo.')

# c
# plotando o gráfico da função
rx = 'x1'
ry = 'x2'
rz= 'f(x1,x2)'
legenda = 'f(x1,x2)'
meu_plot_3D(x1,x2,fx1x2,rx,ry,rz,legenda)

