# Problemas de Desenvolvimento
# 15.04 - melhores valores de a, b e c para a solução da função de Alves[23]

# importando bibliotecas

from scipy.optimize import minimize
import matplotlib.pyplot as p

from numpy import array
import pandas as pd


# função de plotagem
def plotagem(x,y,rx,ry, legenda, mk='k:', titulo = 'Meu gráfico'):

    p.plot(x, y, mk)                                # plotando o gráfico
    p.xlabel(rx)                                    # legenda do eixo X
    p.ylabel(ry)                                    # legenda do eixo Y
    p.title(titulo)                                 # título
    p.legend(legenda)                               # legenda do gráfico
    p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
    p.show()                                        # mostrar a figura
    
    
# declaração da função objetivo

def fabc(a,b,c,M,Ts,Ps,LII,d,u):

    # Ex. 15.3
    result = 1.9881*((0.0002*u*u-0.0015*u+0.3545)/0.3545)*((Ps**a)*d/((Ts**b)*(M**c)*LII))
    
    return result

# declaração da função objetivo
def objFunc(abci,M,Ts,Ps,LII,d,u,ext):
    a,b,c = abci
    
    fxx = fabc(a,b,c,M,Ts,Ps,LII,d,u)
    residuo = sum((ext-fxx)**2)
    return residuo
    
# declaração das variáveis
dados = pd.read_excel('Tabela_exercicio_15.1.xlsx')
u = array(dados['velocidade'])
ext = array(dados['Extensao'])  
M = 26.5        # kg/kmol
Ts = 373.15     # K
Ps = 3.174377e5 # 31.13  # bar --> 3.174377e5kgf/m2
LII = 0.05      # mol/mol
d = 0.0007      # 0.7mm --> 0.0007m

# declaração dos argumentos
argumentos = (M,Ts,Ps,LII,d,u,ext)

# declaração dos limites (variável = [inferior,superior])
a = array([0, 0.5])
b = array([0, 0.5])
c = array([0, 0.5]) 
abc = [a,b,c]

# definição das restrições que serão usadas na função minimize
cons = [{'type':'ineq', 'fun': lambda a: a},
        {'type':'ineq', 'fun': lambda a: 0.5 - a},
        {'type':'ineq', 'fun': lambda b: b},
        {'type':'ineq', 'fun': lambda b: 0.5 - b},
        {'type':'ineq', 'fun': lambda c: c},
        {'type':'ineq', 'fun': lambda c: 0.5 - c}]

# estimativas iniciais
abci = array([0.36,0.36,0.40])

# chamando a função minimize para resolver o problema
solucao = minimize(objFunc, abci, bounds = abc, args=argumentos,
                   constraints=cons, method='SLSQP', tol=1e-15)

# carregando os valores ótimos do x
abco = solucao.x

# a
# imprimindo a solução
print(f'\nOs valores encontrados foram: \na={float(abco[0]): .5f}',
                                          f'\nb={float(abco[1]): .5f} and ',
                                          f'\nc={float(abco[2]): .5f} and ')
# imprimindo os resultados em um gráfico
rx='velocidade(m/s)'
ry='Extensão(m)'
lg = ['teórico', 'abc_otimo']
a,b,c = abco
plotagem(u,ext,rx,ry,lg, mk='ob')
plotagem(u,fabc(a,b,c,M,Ts,Ps,LII,d,u),rx,ry, lg)