# Problemas de Desenvolvimento
# 15.05 - Equação de Henderson et al. [24]

# importando bibliotecas
from scipy.optimize import fsolve


from numpy import array, exp, isclose
  
    
# declaração da função objetivo
def objfunc(A,B1,B2,R,G,D):

    A1 = A[0]
    A2 = A[1]
    
    # Ex. 15.5
    f1 = (1-R)*((D/(10*(1+B1)))-A1)*exp(10*A1/(1+10*(A1/G)))-A1

    # Ex. 15.6
    f2 = A1-(1+B1)*A2+(1-R)*(D/(10-B1*A1-(1+B1)))*A2*exp(10*A2/(1+10*(A2/G)))
    
    return [f1,f2]

# a

# declaração de variáveis
A1 = 1.    # estimativa inicial de alfa 1
A2 = 1.    # estimativa inicial de alfa 2
A = array([A1,A2])
R = 0.935  # razção de reciclo
D = 2.
B1=2
B2 = 2.  # beta1 e beta 2

G = 1000   # gama

Ao = fsolve(objfunc, A, args=(B1,B2,R,G,D))
msg = f'alfa1={Ao[0]:.4e} e alfa2={Ao[1]:.4e} resolvem o siste mapara R={R}.'
print()
print(msg)

# teste de colução
# a função isclose realiza um teste para saber se as raízes encontradas
# retornam um valor próximo de zero quando aplicadas à função
resp = isclose(objfunc(Ao,B1,B2,R,G,D), [0.0, 0.0])
msg2 = f'A solução para a questão a) é {resp[0]}'
msg2 = msg2 + f' para alfa1 e {resp[0]} para alfa2.'
print(msg2)

# b quando mudamos o valor de R para 0.995

R = 0.995  # razção de reciclo
Ao = fsolve(objfunc, A, args=(B1,B2,R,G,D))
msg = f'alfa1={Ao[0]:.4e} e alfa2={Ao[1]:.4e} resolvem o sistema para R={R}.'
print('\n')
print(msg)

# ou seja, os valores das raízes são sensíveis aos valores das constantes
# usadas na equação